/*
 * queries.h
 *
 *  Created on: 2009/10/09
 *      Author: shu
 */

#ifndef QUERIES_H_
#define QUERIES_H_

#include "sequence.h"
#include "sequence_reader.h"
#include "query.h"
#include "aligner_parameters.h"
#include <vector>
#include <string>
#include <stdint.h>

using namespace std;

class Queries {
public:
  Queries(const AlignerParameters &parameters);

  virtual ~Queries() {
    Clear();
  }

  void Next();

  Query *GetQuery(uint32_t id) {
    return queries_[id];
  }
  uint32_t GetNumberSequences() {
    return queries_.size();
  }

  uint32_t GetMaxSequenceLength() {
    return max_sequence_length_;
  }

protected:
  uint32_t GetLength(SequencePtr sequence);
  void SetQuery(SequencePtr sequence);
  void Clear();

  AlignerParameters parameters_;
  vector<Query *> queries_;
  uint32_t max_sequence_length_;
  SequenceReaderPtr reader_;
  SequencePtr next_sequence_;
};

#endif /* QUERIES_H_ */
